#include <NativeModule.h>
#include <eikenv.h>
#include <apgwgnam.h>

class EnvyModule : public NativeModule
	{
private:
	enum
		{
		Hidden, System
		};

	void setHidden(TBool state)
		{
		TInt wgId = CEikonEnv::Static()->RootWin().Identifier();
		RWsSession session = CEikonEnv::Static()->WsSession();
		CApaWindowGroupName* wgName = CApaWindowGroupName::NewLC(session, wgId);
		wgName->SetHidden(state);
		wgName->SetWindowGroupName(CEikonEnv::Static()->RootWin());
		CleanupStack::PopAndDestroy(); // wgName
		}

	void setSystem(TBool state)
		{
		CEikonEnv::Static()->SetSystem(state);
		}
protected:
	TInt ExpectedRuntimeVersion()
		{
		return Runtime::VERSION;
		}

	void ConstructL()
		{
		runtime->AddNativeFunctionL(_L("hide"), 0, 1, Hidden);
		runtime->AddNativeFunctionL(_L("system"), 0, 1, System);
		}

	Runtime::Value ExecuteL(TInt index, Runtime::Value *params,
			TInt paramCount, TRequestStatus &status)
		{

		Runtime::Value result;

		result.SetNull();
		
		TBool type;
		if(paramCount == 1)
			type=params[0].GetBooleanL();
		else
			type = ETrue;
		
		switch (index)
			{
			case Hidden:
				{
				setHidden(type);
				break;
				}
			case System:
				{
				setSystem(type);
				break;
				}
			}
		return result;
		}
	};

EXPORT_C NativeModule* NewEnvyModuleL()
	{
	return new (ELeave) EnvyModule;
	}

#ifndef EKA2
GLDEF_C TInt E32Dll(TDllReason)
	{return KErrNone;}
#endif
